<?php

// Attributes forms
if (isset($_POST['mondialrelay_license_key']) && $_POST['mondialrelay_license_key'] != '') {
    $mondialrelay_license_key = $_POST['mondialrelay_license_key'];
}
else {
    $mondialrelay_license_key = '';
}

	// listen for our activate button to be clicked
	if( isset( $_POST['mondialrelay_license_activate'] ) ) {

		// retrieve the license from the database
		$license = trim( get_option( 'mondialrelay_license_key' ) );


		// data to send in our API request
		$api_params = array(
			'edd_action' => 'activate_license',
			'license'    => $license,
			'item_name'  => urlencode( 'Mondial Relay pour WooCommerce' ),
			'url'        => home_url()
		);

		// Call the custom API.
		$response = wp_remote_post( 'https://mondialrelay-wp.com', array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay
		if ( is_wp_error( $response ) || 200 !== wp_remote_retrieve_response_code( $response ) ) {

			if ( is_wp_error( $response ) ) {
				$message = $response->get_error_message();
			} else {
				$message = __("Une erreur est apparue, veuillez réessayer", 'mondialrelay-wordpress');
			}

		} else {

			$license_data = json_decode( wp_remote_retrieve_body( $response ) );

			if ( false === $license_data->success ) {

				switch( $license_data->error ) {

					case 'expired' :

						$message = sprintf(
							__("Votre clé de licence a expiré le %s.", 'mondialrelay-wordpress'),
							date_i18n( get_option( 'date_format' ), strtotime( $license_data->expires, current_time( 'timestamp' ) ) )
						);
						break;

					case 'disabled' :
					case 'revoked' :
					
						$message = __("Votre clé de licence a été révoquée, veuillez contacter le support.", 'mondialrelay-wordpress');
						break;

					case 'missing' :

						$message = __("Numéro de licence invalide", 'mondialrelay-wordpress');
						break;

					case 'invalid' :
					case 'site_inactive' :

						$message = __("Votre licence n'est pas activée sur ce site", 'mondialrelay-wordpress');
						break;

					case 'item_name_mismatch' :

						$message = sprintf( __("Votre licence n'est pas valide pour %s.", 'mondialrelay-wordpress'), 'Mondial Relay pour WordPress' );
						break;

					case 'no_activations_left':

						$message = __("Votre licence a atteint le nombre limite d'activation autorisée", 'mondialrelay-wordpress');
						break;

					default :

						$message = __("Une erreur est apparue, veuillez réessayer", 'mondialrelay-wordpress');
						break;
				}

			}

		}

		// Check if anything passed on a message constituting a failure
		/*if ( ! empty( $message ) ) {
			$base_url = admin_url( 'plugins.php?page=' . EDD_SAMPLE_PLUGIN_LICENSE_PAGE );
			$redirect = add_query_arg( array( 'sl_activation' => 'false', 'message' => urlencode( $message ) ), $base_url );

			wp_redirect( $redirect );
		}*/

		// $license_data->license will be either "valid" or "invalid"

    update_option( 'mondialrelay_license_status', $license_data->license );
		//wp_redirect( admin_url( 'plugins.php?page=' . EDD_SAMPLE_PLUGIN_LICENSE_PAGE ) );
    }
    

    // listen for our activate button to be clicked
	if( isset( $_POST['mondialrelay_license_deactivate'] ) ) {

		// retrieve the license from the database
		$license = trim( get_option( 'mondialrelay_license_key' ) );


		// data to send in our API request
		$api_params = array(
			'edd_action' => 'deactivate_license',
			'license'    => $license,
			'item_name'  => urlencode( 'Mondial Relay pour WooCommerce' ), // the name of our product in EDD
			'url'        => home_url()
		);

		// Call the custom API.
		$response = wp_remote_post(  'https://mondialrelay-wp.com', array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay
		if ( is_wp_error( $response ) || 200 !== wp_remote_retrieve_response_code( $response ) ) {

			if ( is_wp_error( $response ) ) {
				$message = $response->get_error_message();
			} else {
				$message = __("Une erreur est apparue, veuillez réessayer", 'mondialrelay-wordpress');
			}

            /*
			$base_url = admin_url( 'plugins.php?page=' . EDD_SAMPLE_PLUGIN_LICENSE_PAGE );
			$redirect = add_query_arg( array( 'sl_activation' => 'false', 'message' => urlencode( $message ) ), $base_url );

			wp_redirect( $redirect );
			exit();*/
		}

		// decode the license data
		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

		// $license_data->license will be either "deactivated" or "failed"
		if( $license_data->license == 'deactivated' ) {
			delete_option( 'mondialrelay_license_status' );
		}
	}

// Update options
if (isset($_POST['mondialrelay_licence']) || isset($_POST['mondialrelay_license_activate'])) {
    $envoi = 1;
    $noty = 1;
    update_option( 'mondialrelay_license_key', $mondialrelay_license_key );
}

// Get the options
$mondialrelay_license_key = get_option( 'mondialrelay_license_key' );
$mondialrelay_license_status = get_option( 'mondialrelay_license_status' );

