<?php

 // Main Plugin Class

class class_MRWP_main
{
    const PLUGIN_NAME = 'Mondial Relay - WordPress';
    const VERSION = '3.3';
    const CURRENT_VERSION = 'https://mondialrelay-wp.com';
    const DOCUMENTATION = 'https://mondialrelay-wp.com/doc/';
    const CLIENT = 'https://mondialrelay-wp.com';
    const MENU_POSITION = '58.1';
    const DEBUG = false;
    const MRJAVA = false;
    const DEV = false;
    const SEND_EMAIL = 1;
    const EMAIL_MULTI_LANG = 0;
    const WOOCOMMERCE_FOLDER = 'woocommerce';

    const MONDIALRELAY_WEBSERVICE = 'https://api.mondialrelay.com/Web_Services.asmx?WSDL';
    const MONDIALRELAY_INSCRIPTION = 'https://www.mondialrelay.fr/solutionspro/contact-clients-professionnels/';

    const MONDIALRELAY_MAX_WEIGHT = 30;

    const ENSEIGNE = 'BDTEST13';
    const CODE_MARQUE = '11';
    const CLE_PRIVEE = 'PrivateK';
    const MODE_COL = 'CCC';
    const ASSURANCE = '0';
    const EXPE_PAYS = 'FR';
    const NB_RESULTS = '7';
    const PARCELSHOP_PICKER = '3.3';
    const FANCYBOX = '3.2.10';
    const NB_COLIS = '1';
    const CRT_VALEUR = '0';


// Woocommerce versions compatible with the plugin
    protected $wc_compatibles = array(
        '6.8.0', '6.8.1', '6.8.2', '6.8.3', '6.8.4', '6.8.5', '6.8.6', '6.8.7',
        '6.7.0', '6.7.1', '6.7.2', '6.7.3', '6.7.4', '6.7.5', '6.7.6', '6.7.7',
        '6.6.0', '6.6.1', '6.6.2', '6.6.3', '6.6.4', '6.6.5', '6.6.6', '6.6.7',
        '6.5.0', '6.5.1', '6.5.2', '6.5.3', '6.5.4', '6.5.5', '6.5.6', '6.5.7',
        '6.4.0', '6.4.1', '6.4.2', '6.4.3', '6.4.4', '6.4.5', '6.4.6', '6.4.7',
        '6.3.0', '6.3.1', '6.3.2', '6.3.3', '6.3.4', '6.3.5', '6.3.6', '6.3.7',
        '6.2.0', '6.2.1', '6.2.2', '6.2.3', '6.2.4', '6.2.5', '6.2.6', '6.2.7',
        '6.1.0', '6.1.1', '6.1.2', '6.1.3', '6.1.4', '6.1.5', '6.1.6', '6.1.7',
        '6.0.0', '6.0.1', '6.0.2', '6.0.3', '6.0.4', '6.0.5', '6.0.6', '6.0.7',
        '5.9.0', '5.9.1', '5.9.2', '5.9.3', '5.9.4', '5.9.5', '5.9.6', '5.9.7',
        '5.8.0', '5.8.1', '5.8.2', '5.8.3', '5.8.4', '5.8.5', '5.8.6', '5.8.7',
        '5.7.0', '5.7.1', '5.7.2', '5.7.3', '5.7.4', '5.7.5', '5.7.6', '5.7.7',
        '5.6.0', '5.6.1', '5.6.2', '5.6.3', '5.6.4', '5.6.5', '5.6.6', '5.6.7',
        '5.5.0', '5.5.1', '5.5.2', '5.5.3', '5.5.4', '5.5.5', '5.5.6', '5.5.7',
        '5.4.0', '5.4.1', '5.4.2', '5.4.3', '5.4.4', '5.4.5', '5.4.6', '5.4.7',
        '5.3.0', '5.3.1', '5.3.2', '5.3.3', '5.3.4', '5.3.5', '5.3.6', '5.3.7',
        '5.2.0', '5.2.1', '5.2.2', '5.2.3', '5.2.4', '5.2.5', '5.2.6', '5.2.7',
        '5.1.0', '5.1.1', '5.1.2', '5.1.3', '5.1.4', '5.1.5', '5.1.6', '5.1.7',
        '5.0.0', '5.0.1', '5.0.2', '5.0.3', '5.0.4', '5.0.5', '5.0.6', '5.0.7',
        '4.9.0', '4.9.1', '4.9.2', '4.9.3', '4.9.4', '4.9.5', '4.9.6', '4.9.7',
        '4.8.0', '4.8.1', '4.8.2', '4.8.3', '4.8.4', '4.8.5', '4.8.6', '4.8.7',
        '4.7.0', '4.7.1', '4.7.2', '4.7.3', '4.7.4', '4.7.5', '4.7.6', '4.7.7',
        '4.6.0', '4.6.1', '4.6.2', '4.6.3', '4.6.4', '4.6.5', '4.6.6', '4.6.7',
        '4.5.0', '4.5.1', '4.5.2', '4.5.3', '4.5.4', '4.5.5', '4.5.6', '4.5.7',
        '4.4.0', '4.4.1', '4.4.2', '4.4.3', '4.4.4', '4.4.5', '4.4.6', '4.4.7',
        '4.3.0', '4.3.1', '4.3.2', '4.3.3', '4.3.4', '4.3.5', '4.3.6', '4.3.7',
        '4.2.0', '4.2.1', '4.2.2', '4.2.3', '4.2.4', '4.2.5', '4.2.6', '4.2.7',
        '4.1.0', '4.1.1', '4.1.2', '4.1.3', '4.1.4', '4.1.5', '4.1.6', '4.1.7',
        '4.0.0', '4.0.1', '4.0.2', '4.0.3', '4.0.4', '4.0.5', '4.0.6', '4.0.7',
        '3.8.0', '3.8.1', '3.9.0', '3.9.1', '3.9.2', '3.9.3', '3.9.4', '3.9.5',
        '3.6.0', '3.6.1', '3.6.2', '3.6.3', '3.6.4', '3.6.5', '3.7.0', '3.7.1',
        '3.5.0', '3.5.1', '3.5.2', '3.5.3', '3.5.4', '3.5.5', '3.5.6', '3.5.7', '3.5.8',
        '3.4.0', '3.4.1', '3.4.2', '3.4.3', '3.4.4', '3.4.5', '3.4.6', '3.4.7',
        '3.3.5', '3.3.4', '3.3.3', '3.3.2', '3.3.1' ,'3.3.0',
        '3.2.6', '3.2.5', '3.2.4', '3.2.3', '3.2.2', '3.2.1', '3.2.0',
        '3.1.2', '3.1.1', '3.1.0',
        '3.0.9', '3.0.8', '3.0.7', '3.0.6', '3.0.5', '3.0.4', '3.0.3', '3.0.2', '3.0.1', '3.0.0'
    );

// Protected var

    protected $loader; // Maintains and registers all hooks for the plugin.
    protected $plugin_name; // The string used to uniquely identify this plugin.
    protected $version; //The version of the plugin.
    protected $dev; // Dev mode
    protected $debug; // Debug mode
    protected $menu_position; // Menu position
    protected $woocommerce_folder; // WooCommerce folder
    protected $current_version; // The current version of the plugin
    protected $documentation; // Documentation of the plugin
    protected $client; // Client's account link
    protected $compatible; // compatibility of the plugin
    protected $wc_version; // WooCommerce version


// Class Constructor
// Load the dependencies, define the locale, and set the hooks for the admin & public areas
    public function __construct()
    {
        $this->plugin_name = self::PLUGIN_NAME;
        $this->version = self::VERSION;
        $this->dev = self::DEV;
        $this->debug = self::DEBUG;
        $this->menu_position = self::MENU_POSITION;
        $this->current_version = self::CURRENT_VERSION;
        $this->documentation = self::DOCUMENTATION;
        $this->client = self::CLIENT;

        $this->load_dependencies();
        $this->set_locale();


        // Get the debug mode
        $this->mode_debug();
        // Load scripts and styles (if checkout page)
        $this->define_public_hooks();
        // Functions call for the administration of the plugin
        if (is_admin()) {
            // Get the position plugin in the menu
            $this->menu_position();
            // Get the folder name of WooCommerce
            $this->woocommerce_folder();
            // Admin hooks
            $this->define_admin_hooks();
            // Configuration functions
            require_once plugin_dir_path(dirname(__FILE__)) . 'inc/class-MRWP-db.php';
            require_once plugin_dir_path(dirname(__FILE__)) . 'inc/class-MRWP-conf.php';
            require_once plugin_dir_path(dirname(__FILE__)) . 'inc/class-MRWP-helpers.php';
            require_once plugin_dir_path(dirname(__FILE__)) . 'inc/class-MRWP-order.php';
        }

        // Check if the WooCommerce version is compatible with the plugin
        if (!$this->compatible()) {
            if (is_admin()) {
                add_action('admin_notices', array($this, 'notification_compatibilite'));
            }
        }
    }

// Get WooCommerce version
    public function version()
    {
        if (!function_exists('get_plugins')) {
            require_once(ABSPATH . 'wp-admin/includes/plugin.php');
        }
        $plugin_folder = get_plugins('/' . 'woocommerce');
        $plugin_file = 'woocommerce.php';
        if (isset($plugin_folder[$plugin_file]['Version'])) {
            $this->wc_version = $plugin_folder[$plugin_file]['Version'];
        } else {
            $this->wc_version = null;
        }
    }

// Check compatibility with WooCommerce
    public function compatible()
    {
        // Get WooCommerce version
        $this->version();
        // Check if WooCommerce version is compatible
        if (in_array($this->wc_version, $this->wc_compatibles)) {
            return true;
        } else {
            return false;
        }
    }


// Notification if the plugin is not compatible with the version of WooCommerce
    public function notification_compatibilite()
    {
        echo "<div class='notice notice-warning is-dismissible'>";
        //echo "<div class='update-nag'>";
        echo '<h3>';
        _e("Plugin Mondial Relay - WordPress", 'mondialrelay-wordpress');
        echo '</h3>';
        //echo '<h4 style="color: #ff0000">';
        //_e("Problème de compatibilité", 'mondialrelay-wordpress');
        //echo '</h4>';
        echo $compatibilite_old = sprintf(__("La version <strong>%s</strong> de WooCommerce n'a pas été testée avec votre version <strong>%s</strong> du plugin Mondial Relay pour WordPress.", 'mondialrelay-wordpress'), $this->wc_version, $this->version);
        // if WooCommerce is newer than the last version supported by the plugin
        if (version_compare($this->wc_version, $this->wc_compatibles[0], '>')) {
            echo '<p>';
            _e("Vérifiez que votre version est bien à jour en vous rendant sur votre compte en ligne ", 'mondialrelay-wordpress');
            echo '<a href="https://mondialrelay-wp.com/mon-compte/" target="_blank">Mon Compte</a>.';
            echo '</p>';
        }
        //echo $compatibilite_old3 = sprintf(__('<a href="%s/maj" target="_blank">Plus d\'informations</a>', 'mondialrelay-wordpress'), self::DOCUMENTATION);
        //echo "</div>";
        echo "</div>";
    }


// Get debug mode
    public function mode_debug()
    {
        $this->debug = get_option('mondialrelay_debug', 0);
    }

// Get position plugin in the menu
    public function menu_position()
    {
        $this->menu_position = get_option('mondialrelay_menu_position', self::MENU_POSITION);
    }

// Get WooCommerce folder
    public function woocommerce_folder()
    {
        $this->woocommerce_folder = get_option('mondialrelay_woocommerce_folder', self::WOOCOMMERCE_FOLDER);
    }

// Load the required dependencies for this plugin
    private function load_dependencies()
    {
        // Actions and filters
        // @todo Refactoring mettre plugin_dir_path(dirname(__FILE__)) dans une variable
        require_once plugin_dir_path(dirname(__FILE__)) . 'inc/class-MRWP-loader.php';

        // Mondial Relay shipping modes
        require_once plugin_dir_path( __DIR__ ) . 'inc/class-MRWP-modes.php';

        // internationalization functionality
        require_once plugin_dir_path(dirname(__FILE__)) . 'inc/class-MRWP-i18n.php';

        // Admin area
        require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-MRWP-admin.php';
        require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-MRWP-mass-shipping.php';
        require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-MRWP-history.php';
        require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-MRWP-mass-list-table.php';
        require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-MRWP-history-list-table.php';

        // Public Area
        require_once plugin_dir_path(dirname(__FILE__)) . 'public/class-MRWP-public.php';
        $this->loader = new class_MRWP_loader();
    }

// Define the locale for this plugin for internationalization
    private function set_locale()
    {
        $plugin_i18n = new class_MRWP_i18n();
        $plugin_i18n->set_domain('mondialrelay-wordpress');
        $this->loader->add_action('plugins_loaded', $plugin_i18n, 'load_plugin_textdomain');
    }

// Hooks for the admin part
    private function define_admin_hooks()
    {
        $plugin_admin = new class_MRWP_admin($this->get_plugin_name(), $this->get_version(), $this->get_current_version(), $this->get_menu_position());
        $this->loader->add_action('plugin_row_meta', $plugin_admin, 'plugin_row_meta', 10, 2);
        $this->loader->add_action('admin_menu', $plugin_admin, 'MondialRelayMenu');
     //   $this->loader->add_action('admin_menu', $plugin_admin, 'notificationMenu');
        $this->loader->add_action('add_meta_boxes', $plugin_admin, 'actions_mr_meta_box');
        $this->loader->add_action('admin_footer', $plugin_admin, 'expedition_javascript');
        $this->loader->add_action('admin_footer', $plugin_admin, 'tracking_javascript');
        $this->loader->add_action('wp_ajax_expedition', $plugin_admin, 'expedition_callback');
        $this->loader->add_action('wp_ajax_tracking', $plugin_admin, 'tracking_callback');
        $this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_styles');
        $this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts');

        // Hooks for Mass expedition
        $this->loader->add_action( 'wp_ajax_mrwp_cancel_expedition', 'MRWP_Mass_Shipping', 'cancel_expedition' );
        $this->loader->add_action( 'wp_ajax_mrwp_create_expedition', 'MRWP_Mass_Shipping', 'fetch_creation' );
        $this->loader->add_action( 'wp_ajax_mrwp_display_mass', 'MRWP_Mass_Shipping', 'display' );
        $this->loader->add_action( 'wp_ajax_mrwp_refresh_mass', 'MRWP_Mass_Shipping', 'display_refresh' );
        $this->loader->add_action( 'wp_ajax_mrwp_update_weight', 'MRWP_Mass_Shipping', 'update_weight' );
        $this->loader->add_action( 'wp_ajax_mrwp_impression', 'MRWP_Mass_Shipping', 'fetch_impression' );
        $this->loader->add_action( 'wp_ajax_mrwp_update_weight', 'MRWP_Mass_Shipping', 'update_weight' );

        // Hooks for expedition history
        $this->loader->add_action( 'wp_ajax_mrwp_display_history', 'MRWP_History', 'display' );
        $this->loader->add_action( 'wp_ajax_mrwp_refresh_history', 'MRWP_History', 'display_refresh' );
        $this->loader->add_action( 'wp_ajax_mrwp_export_history',  'MRWP_History', 'export_csv' );
        $this->loader->add_action( 'wp_ajax_mrwp_update_status',   'MRWP_History', 'update_status' );
        $this->loader->add_action( 'woocommerce_order_data_store_cpt_get_orders_query', 'MRWP_History', 'get_orders_meta', 10, 2 );

    }

    /**
     * These hooks are always available
     */
    public function define_public_hooks()
    {
        $plugin_public = new class_MRWP_public($this->get_plugin_name(), $this->get_version(), $this->get_dev(), $this->get_debug());
        $this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_styles');
        $this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_scripts', 9);
        $this->loader->add_action('woocommerce_cart_totals_after_order_total', $plugin_public, 'display_cart_weight');
        $this->loader->add_action('woocommerce_review_order_after_shipping', $plugin_public, 'modaal_link');
        $this->loader->add_action('woocommerce_after_order_notes', $plugin_public, 'modaal_content');
        $this->loader->add_action('woocommerce_after_order_notes', $plugin_public, 'my_custom_checkout_field');

        // Load Mondial Relay shipping method when WooCommerce is ready
        $this->loader->add_action( 'woocommerce_shipping_init', __CLASS__, 'load_shipping_class' );
        add_filter( 'woocommerce_shipping_methods', array( 'MRWP_Shipping_Method', 'add_shipping_method' ) );

        // Optionally add Mondial Relay logo and description in cart
        add_filter( 'woocommerce_cart_shipping_method_full_label', array( 'MRWP_Shipping_Method', 'embellish_label' ), 10, 2 );
    }

    /**
     * Shipping class loader
     */
    public static function load_shipping_class()
    {
        require_once plugin_dir_path( __DIR__ ) . 'shipping-method/class-shipping-method.php';
    }

// Check that a Delivery Point has been chosen when mandatory
    public function parcel_custom_validation() {

        // Check that a Delivery Point has been chosen when mandatory
        if ( isset( $_POST['mrwp_parcel_shop_mandatory'] )) {

            $mrwp_parcel_shop_mandatory = sanitize_text_field( $_POST['mrwp_parcel_shop_mandatory']);
            if ( "Yes" == $mrwp_parcel_shop_mandatory && empty( $_POST['mrwp_parcel_shop_id'] ) ) {

                // Get all enabled payment methods
                $gateways = WC()->payment_gateways->get_available_payment_gateways();

                // If PayPal CheckOut from WooCommerce is enabled, we don't use wc_add_notice because it doesn't block the payment
                if (array_key_exists('ppec_paypal', $gateways)) {
                    throw new Exception(__( 'Merci de choisir un <strong>Point Relais®</strong>.', 'mondialrelay-wordpress' ));
                } else {
                    wc_add_notice( __( 'Merci de choisir un <strong>Point Relais®</strong>.', 'mondialrelay-wordpress' ), 'error' );
                }
            }
        }

        //Block checkout if Parcel too heavy no more Shipping Method selected
        if ( isset( $_POST['mrwp_too_heavy_block_checkout'] )) {
            $mrwp_too_heavy_block_checkout = sanitize_text_field( $_POST['mrwp_too_heavy_block_checkout']);
            if ( "Yes" == $mrwp_too_heavy_block_checkout ) {
                wc_add_notice( __( 'Aucune méthode de livraison disponible pour un panier de ce poids.'.' '.'<a href="'.wc_get_cart_url().'">'.__("Revenir au panier","mondialrelay-wordpress").'</a>', 'mondialrelay-wordpress' ), 'error' );
            }
        }
    }



// Save Delivery Point chosen
    public function save_mondial_relay_shipping_meta($order_id)
    {
        if ($_POST['mrwp_parcel_shop_id']) {
            update_post_meta($order_id, 'Mondial Relay Parcel Shop ID', sanitize_text_field($_POST['mrwp_parcel_shop_id']));
        }
        if ($_POST['mrwp_parcel_shop_address']) {
            update_post_meta($order_id, 'Mondial Relay Parcel Shop Address', sanitize_textarea_field($_POST['mrwp_parcel_shop_address']));
        }
        if ($_POST['mrwp_shipping_code']) {
            update_post_meta($order_id, 'Mondial Relay Shipping Code', sanitize_text_field($_POST['mrwp_shipping_code']));
        }
        if (isset($_POST['mrwp_weight'])) {
            update_post_meta($order_id, 'Mondial Relay Parcel Weight', sanitize_text_field($_POST['mrwp_weight']));
        }
        if (isset($_POST['mrwp_user_lang'])) {
            update_post_meta($order_id, 'Mondial Relay User Lang', sanitize_text_field($_POST['mrwp_user_lang']));
        }

    }

    /**
     * Change delivery address to Mondial Relay Parcel Shop Address
     *
     * Record package weight instead of products weight
     */
    public function update_shipping_fields( $order_id )
    {
        $parcel_shop = get_post_meta( $order_id, 'Mondial Relay Parcel Shop Address', 1 );
        if ( isset( $parcel_shop ) && ! empty( $parcel_shop ) ) {

            //Store as is in _shipping_address_index
            update_post_meta( $order_id, '_shipping_address_index', $parcel_shop );

            // Split for the other fields
            if (strpos($parcel_shop, "-MRWP-") !== false) {
                // New seperator
                $parcel_shop = explode( "-MRWP-", $parcel_shop );
            } else {
                // Old Separator (in case there is a difference between PHP version and JS version because of a CDN)
                $parcel_shop = explode( "\n", $parcel_shop );
            }

            $parcel_shop = str_replace( "\n","", $parcel_shop );
            $parcel_shop = str_replace( "\r","", $parcel_shop );
            update_post_meta( $order_id, '_shipping_company',   $parcel_shop[0] );
            update_post_meta( $order_id, '_shipping_address_1', $parcel_shop[1] );
            update_post_meta( $order_id, '_shipping_address_2', $parcel_shop[2] );
            update_post_meta( $order_id, '_shipping_postcode',  $parcel_shop[3] );
            update_post_meta( $order_id, '_shipping_city',      $parcel_shop[4] );
            update_post_meta( $order_id, '_shipping_country',   $parcel_shop[5] );

            /*
             * Calculate package weight
             */

             // Get weigth in grams from order
            $net_weight = get_post_meta( $order_id, 'Mondial Relay Parcel Weight', true );

            // convert grams to kg
            $weight_in_kg = (float)$net_weight / 1000.0;

            // Retrieve shipping method from order
            $order     = wc_get_order( $order_id );
            $shippings = $order->get_items( 'shipping' );
            $shipping  = reset( $shippings );  // Get first element from array

            // Instantiate our own shipping class to retrieve the tare
            $shipping_method = new MRWP_Shipping_Method( $shipping->get_instance_id() );
            $tare            = $shipping_method->get_tare_for_weight( $weight_in_kg );

            // And save gross weight in grams
            $gross_weight = (int)$net_weight + (int)($tare * 1000);
            update_post_meta( $order_id, 'Mondial Relay Parcel Weight', $gross_weight );
        }
    }

// Function called after loaded WooCommerce
    public function woocommerce_loaded()
    {   //Add custom validation
        add_action('woocommerce_checkout_process', array($this , 'parcel_custom_validation'));
        // Save attributes
        add_action('woocommerce_checkout_update_order_meta', array($this , 'save_mondial_relay_shipping_meta'));
        // Modifiy delivery address if Mondial Relay is selected
        add_action('woocommerce_checkout_update_order_meta', array($this , 'update_shipping_fields'));
    }

// Load Mondial Relay order functions when checkout page is active
    public function plugin_is_checkout()
    {
        if (is_checkout()) {
            require_once plugin_dir_path(dirname(__FILE__)) . 'inc/class-MRWP-order.php';
        }
    }

// Function called after loaded all the plugin
    public function plugins_loaded()
    {
        // Load checkout functions
        add_action('template_redirect', array($this , 'plugin_is_checkout'), 9);
    }

// Run the loader to execute all of the hooks with WordPress
    public function run()
    {
        // Function called after loaded WooCommerce
        $this->loader->add_action('woocommerce_init', $this, 'woocommerce_loaded');
        // Function called after loaded all the plugin
        $this->loader->add_action('plugins_loaded', $this, 'plugins_loaded');
        $this->loader->run();
    }

// Accessors
    public function get_plugin_name() // Plugin name
    {
        return $this->plugin_name;
    }

    public function get_loader() // Orchestrates the hooks of the plugin
    {
        return $this->loader;
    }

    public function get_version() // The version number of the plugin
    {
        return $this->version;
    }

    public function get_current_version() // The version number of WooCommerce
    {
        return $this->current_version;
    }

    public function get_menu_position() // menu position of the plugin
    {
        return $this->menu_position;
    }

    public function get_documentation() // Documentation link of the plugin
    {
        return $this->documentation;
    }

    public function get_dev() // Mode of the plugin
    {
        return $this->dev;
    }

    public function get_debug() // Debug mode of the plugin
    {
        return $this->debug;
    }

// Get WooCommerce version
    public static function woocommerce_version()
    {
        if (!function_exists('get_plugins')) {
            require_once(ABSPATH . 'wp-admin/includes/plugin.php');
        }
        $plugin_folder = get_plugins('/' . 'woocommerce');
        $plugin_file = 'woocommerce.php';
        if (isset($plugin_folder[$plugin_file]['Version'])) {
            $version = $plugin_folder[$plugin_file]['Version'];
        } else {
            $version = null;
        }
        return $version;
    }
}